(****************************************************************************)
(*
(*                           
(*                      
(*                       
(*                  
(*            
(*            
(*             
(*             
(*                
(*                           
(*                                       
(*
(*
(*					   Wildcat mail tosser V2.7
(*				  Wildcat wcTOSS Config program V1.6
(*
(*				 Copyright 1994,95,96 Michael Dailly
(*
(*  Copyright Notice
(*	----------------
(*
(*	  Michael Dailly retains ALL copyright to this program and its source.
(*	  The user may alter or amend the source in anyway he or she wishes.
(*	  However, the program may NOT be sold, but must be given freely and
(*	  any changes (including full source) must be sent to the Author
(*	  (Michael Dailly). Failing to do so is a violation of copyright. 
(*    The Authors name (Michael Dailly) MUST appear in the programs 
(*    copyright notice, and in any documentation, and it must clearly 
(*    state that the program is a modification of wcTOSS. The full modified 
(*	  source code must be included in the programs archive for all to 
(*	  use and examine. 
(*
(*
(*	 This copyright notice,and the authors name(s) must remain in all files.
(*
(*
(* Ver 1.0    Basic config. Name, address, paths etc..
(*
(* Ver 1.2    Allow area editing+nodes IN area.
(*            Allow password editing
(*            Allow crashmail NAME editing
(*
(* Ver 1.3    New format and options in wcTOSS.cfg added.
(*
(* Ver 1.4    Crashed if there was no areas.bbs file -*fixed*-
(*            Deleting things from a LIST was going wrong and crashing
(*            the machine. -* fixed *-
(*
(* Ver 1.5    Added in HELP menus on main menu screen.
(*
(* Ver 1.6    Added in Line editing for inputing strings.
(*
(****************************************************************************)
{$M 16384,32768,640000}
Program	wcTOSSConfig;

uses		dos,crt,func,qwksort,ScreenIO;

type      tInput = record
                     txt   : string[40];
                     start : integer;
                     len   : integer;
                     max   : integer;
                     Flags : byte;
                   End;
          tAinput= array[1..100] of tInput;
          pInput = ^tAInput;


const     VERC   = 'V1.6';
          before = false;
          after  = true;
          Months :    array [1..12] of string[3] =('JAN','FEB','MAR','APR',
                                              'MAY','JUN','JUL','AUG',
                                              'SEP','OCT','NOV','DEC');
          Days : array [0..6] of string[3] = ('Sun','Mon','Tue','Wed','Thu',
                                           'Fri','Sat');
          HelpFile: array [1..14] of string[25]=
	             ('[NAME]','[NETMAIL]','[BADMAIL]','[INCOMMING]',
                   '[OUTGOING]','[PACKER]','[NONE]',
			    '[AKAS]','[ORIGIN]','[CRASHMAIL]','[GROUPS]',
                   '[NONE]','[SAVEQUIT]','[QUIT]');


          P_Name   : array[1..1] of tInput=( (txt:'#cA#b1Name : #cF';  Start:8;  len:30;  max:80) );
          P_Path   : array[1..1] of tInput=( (txt:'#cA#b1Path : #cF';  Start:8;  len:30;  max:80) );
          P_Packer : array[1..4] of tInput=(
                                 (txt:'#cA#b1Packer   : #cF';  Start:12;  len:30;  max:80),
                                 (txt:'#cA#b1Options  : #cF';  Start:12;  len:30;  max:80),
                                 (txt:'#cA#b1UnPacker : #cF';  Start:12;  len:30;  max:80),
                                 (txt:'#cA#b1Options  : #cF';  Start:12;  len:30;  max:80));
          P_Group : array[1..2] of tInput=(
                                 (txt:'#cA#b1Area Name          : #cF';  Start:22;  len:30;  max:30),
                                 (txt:'#cA#b1Conference Number  : #cF';  Start:22;  len:5;   max:5));



type      tHelps = array[1..1000] of string[25];
		pHelps = ^tHelps;



		tLine	=	record
                          next	:    pointer;
          			 group	:	string[60];
                          conf	:	string[5];
                          Node     :    pointer;       { point to NODE list }
                         end;
          pLine	=	^tLine;

		tGroup	=	record
                          next	:    pointer;
          			 group	:	string[60];
                          conf	:	string[5];
                          Node     :    pointer;       { point to NODE list }
                         end;
          pGroup	=	^tGroup;
		tName 	=	record
                          next	:    pointer;
          			 Name	:	string[60];
                          conf	:	string[5];     { dummy }
                          Dummy    :    pointer;       { dummy }
                         end;
          pName 	=	^tName;
		tPassword =	record
                          next	:    pointer;
          			 Password :	string[60];
                          conf	:	string[5];     { dummy }
                          Dummy    :    pointer;       { dummy }
                         end;
          pPassword =	^tPassword;

		tNode	=	record
                          next	:    pointer;
          			 Node	:	string[60];
                          conf	:	string[5];     { dummy }
                          Dummy    :    pointer;       { dummy }
                         end;
          pNode	=	^tNode;

		tAKA 	=	record
                          next	:    pointer;
          			 Add		:	string[60];	{ list of addresses }
                          conf	:	string[5];     { dummy }
                          Dummy    :    pointer;       { dummy }
                         end;
		pAKA		=	^tAKA;

		tTag 	=	record
                          next	:    pointer;
          			 Tag		:	string[60];	{ Tag line }
                          conf	:	string[5];     { dummy }
                          Dummy    :    pointer;       { dummy }
                         end;
		pTag		=	^tTag;

		tConf 	=	record
                          next	:    pointer;
          			 Conf	:	word;	{ conf number }
                          Tag		: 	word;	{ tag  number }
                          add		:	word;	{ aka  number }
                         end;
		pConf	=	^tConf;



var       T		:	Text;
		s,st		:	String;
          Done		:	boolean;

		W1,W2	:	integer;
          i,i2,i3	:	integer;
          Option	:	integer;
          p         :    pointer;

          Packer	:	string;
          UNPacker	:	string;
          packero	:	string;
          unpackero	:	string;
          Name      :    string;   { My Name               }
          address	:	string;   { My fido address       }
          dest		:	string;   { outgoing MAIL path    }
          Inpath	:	string;   { In comming MAIL path  }
          NetMail   :    string;   { Netmail address       }
          Orig      :    string;   { my Origin line        }
          badmail	:	string;

          TS		:	string;

          Line		:	pLine;
          Last		:	pLine;
          Start	:	pLine;
          Temp		:	pLine;

          StartAreas     :	pGroup;    { varous STARTING points for the linked lists }
          StartNodes     :    pNode;
          StartPasswords :	pPassword;

          AKAStart	:	pAka;
          LAKA		:	pAka;
          TagStart	:	pTag;
          LTag		:	pTag;
          NameStart	:	pName;
          LName	:	pName;
          ConfStart	:	pConf;
          LConf	:	pConf;
          HelpData  :    pHelps;



          dirinfo        :    searchrec;

Function EditList (s1,s2 : string; Xsize : word; VAR base : pointer;Call : boolean; c,b,tcol :word) : boolean; forward;



(****************************************************************************)
(*
(*	Get a byte/word.
(*   This buffers up to 64k of a file, it allows files LARGER than
(*   the PC fav of 64k. It also allows the file pointer to move BACKWARDS!
(*
(*   (Sort of like Virtual memory for reading files)
(*
(****************************************************************************)

{ Variables and constants needed for READBYTE }
const	BS   	= 65000;
		BS2  	= 65004;
type		tBuffer	=	array [0..BS2] of byte;
		pBuffer	=	^tBuffer;
var		BUFF   :	file;
          BUFFER :  pBuffer;
		INDEX  :	longint;
          SINDEX :  longint;
		SIZE   :	longint;

{ Actual function }
function ReadByte : byte;
		VAR ii : longint;
Begin
	if (index>=Size) then
     Begin
     	ReadByte:=0;
          exit;
     End;
     if (index>sindex+BS-1) or (index<SIndex) then
     Begin
        Seek (BUFF,index);
        if size>index+BS-1 then
	   	Begin
	   		ii:=BS;
        		Sindex:=index;
        	End
        else
          Begin
          	ii:=Size-index;		{ get amount LEFT in file! }
        		Sindex:=index;
        	End;
        blockread (BUFF,Buffer^[0],ii);  { read in file }
     End;
	readbyte:=Buffer^[index-SIndex];
	inc (index);
End;

function ReadWord : word;
         VAR i : word;
Begin
     i:=ReadByte;
     i:=i+ReadByte*256;
     ReadWord:=i;
End;
(***************************************************************************)
(*
(*	Close Screen
(*
(***************************************************************************)
Procedure CloseScreen;
Begin
	CloseWindow (w1);
	CloseWindow (w2);
     for i:=0 to 1999 do Screen^[i]:=$20+$700;
	gotoxy (1,1);
     Window (1,1,79,24);
End;


(***************************************************************************)
(*
(*   Blank Status Lines!
(*
(***************************************************************************)
Procedure BlankLines(s1,s2:string);
          VAR i : word;
Begin
     if s1<>'!' then for i:=0 to 79 do Screen^[i]:=32+$7000;
     if s2<>'!' then for i:=0 to 79 do Screen^[i+1920]:=32+$7000;

     setxy (0,0);
     tc:=14;
     tb:=7;
     if (s1<>'!') and (s1<>'') then MyWriteln (-1,0,s1);
     if (s2<>'!') and (s2<>'') then MyWriteln (-1,24,s2);
End;


(***************************************************************************)
(*
(*   Print Up Window
(*
(***************************************************************************)
Procedure PrintScreen;
          VAR i : word;
Begin
     for i:=0 to 1999 do Screen^[i]:=177+$7100;
     BlankLines('#cE  wcTOSS Configure '+VERC,'Copyright Michael Dailly 1994,95');
     MyWrite(78,23,'#c7#b1MD');

End;

(***************************************************************************)
(*
(* Get a string of text, and stop if I hit a space, or newline.
(*
(***************************************************************************)
Function GetText : string;
         VAR i : integer;
         VAR a : byte;
         VAR s : string;
Begin
     a:=readbyte;
     while ((a=32) or (a=9)) and (index<size) do
     Begin
          a:=readbyte;
     End;

     { Newline? }
     if a=13 then
     Begin
          GetText:=char(a);
          inc (index);
          exit;
     End;

     { read in STRING }
     s:='';
     while (a<>32) and (a<>9) and (a<>13) and (index<size) do
     Begin
          s:=s+char(a);
          a:=readbyte;
     End;
     GetText:=s;
     if index>=size then exit;
     dec (index);
End;


(***************************************************************************)
(*
(*	readin Areas.bbs file
(*
(***************************************************************************)
Procedure ReadAreas;
		VAR t: text;
          VAR s,s2 : string;
          VAR conf,group : string;
          VAR Line,Last : pGroup;
          VAR Node : pNode;
          VAR LastNode : pNode;
Begin
     findfirst ('areas.bbs',AnyFile,DirInfo);
     if (DosError<>0) then exit;
     new (Buffer);
	assign (Buff,'areas.bbs');
     reset  (Buff,1);
     Size:=FileSize(Buff);
	StartAreas:=NIL;
     Done:=False;
     index:=0; Sindex:=1;  { Setup the FIRST byte }

     repeat
          s:=GetText;
     	if (s<>#13) and (s<>'') then
          Begin
     { First make structure of a GROUP }
               Conf:=s;
               Group:=GetText;
               new (Line);
               if StartAreas=NIL then StartAreas:=Line;
               Line^.group:=Group;
               Line^.conf:=Conf;
               Line^.Next:=NIL;
               Line^.Node:=NIL;
               if Last<>NIL then Last^.Next:=Line;
          	Last:=Line;


     { Now check for NODES, and if so, make structures for THAT! }
               s:=GetText;
               LastNode:=NIL;
               while (s<>#13) and (s<>'') do
               Begin
                    new (Node);
                    Node^.Node:=s;
                    Node^.Next:=NIL;
                    Node^.Dummy:=NIL;
                    Node^.conf:='0';

                    if LastNode<>NIL then LastNode^.Next:=Node;
          	     LastNode:=Node;
                    if Line^.Node=NIL then Line^.Node:=Node;
                    s:=GetText;
               End;
          End;
     until (index>=size);
     Dispose (buffer);
End;
(***************************************************************************)
(*
(*	readin AKAS
(*
(***************************************************************************)
Procedure ProcessNames;
		VAR Name : pName;
Begin
	readln (t,ts);
     while (ts[1]<>'-') do
     Begin
          new (Name);
          Name^.Name:=ts;
          name^.next:=NIL;
          if NameStart=NIL then NameStart:=Name;
     	if LName<>NIL then LName^.next:=Name;
          LName:=Name;
		readln (t,ts);
     End;
End;

(***************************************************************************)
(*
(*	readin AKAS
(*
(***************************************************************************)
Procedure ProcessTAGs;
		VAR Tag : pTag;
Begin
	readln (t,ts);
     while (ts[1]<>'-') do
     Begin
          new (Tag);
          Tag^.Tag:=ts;
          Tag^.next:=NIL;
          if TagStart=NIL then TagStart:=Tag;
     	if Ltag<>NIL then LTag^.next:=Tag;
          Ltag:=Tag;
		readln (t,ts);
     End;
End;

(***************************************************************************)
(*
(*	readin AKAS
(*
(***************************************************************************)
Procedure ProcessAKAs;
		VAR AKA : pAka;
Begin
	readln (t,ts);
     while (ts[1]<>'-') do
     Begin
          new (aka);
          aka^.add:=ts;
          aka^.next:=NIL;
          if AkaStart=NIL then AkaStart:=Aka;
     	if LAka<>NIL then LAka^.next:=Aka;
          LAka:=Aka;
		readln (t,ts);
     End;
End;

(***************************************************************************)
(*
(* process CONFS
(*
(***************************************************************************)
Procedure ProcessConfs;
		VAR CONF : pConf;
Begin
	readln (t,ts);
     while (ts[1]<>'-') do
     Begin
          new (Conf);
          Conf^.Conf:=Rval(ts);
          readln (t,ts);
          Conf^.Tag :=Rval(ts);
          readln (t,ts);
          Conf^.add :=Rval(ts);
          Conf^.next:=NIL;

          if ConfStart=NIL then ConfStart:=Conf;
     	if LConf<>NIL then LConf^.next:=Conf;
          LConf:=Conf;
		readln (t,ts);
     End;
End;



(***************************************************************************)
(*
(*	readin wcTOSS.cfg file
(*
(***************************************************************************)
Procedure ReadCFG;
          VAR s : string;
          VAR LastN : pName;
          VAR Line  : pName;
          VAR Lastp : pPassword;
          VAR Line2 : pPassword;
Begin
     findfirst ('wcTOSS.dat',anyfile,dirinfo);
     if doserror<>0 then exit; { cant find it? }

     assign (t,'wcTOSS.dat');
     reset (t);

     readln (t,netmail);
     readln (t,badmail);
     readln (t,InPath);
     readln (t,dest);
     readln (t,name);
     readln (t,packer);
     readln (t,packerO);
     readln (t,unpacker);
     readln (t,unpackerO);

     NameStart:=NIL;
     AKAStart:=NIL;
     TAGStart:=NIL;
     LTag:=NIL;
     LAKA:=NIL;
     LName:=NIL;
     readln (t,ts);
     while (not eof(t)) do
     Begin
		if ts='-AKAS-' then ProcessAKAs else
		if ts='-TAGS-' then ProcessTAGs else
		if ts='-NAMES-' then ProcessNames else
          if ts='-CONFS-' then ProcessCONFS
          else readln (t,ts);
     End;

End;
(***************************************************************************)
(*
(*   Save Groups.bbs and areas.bbs file
(*
(***************************************************************************)
Procedure SaveGroups;
          VAR t : text;
          VAR line : pGroup;
          VAR line2 : pNode;
          VAR s : string;
          VAR conf : pConf;
          VAR Aka : pAka;
          VAR Tag : pTag;
          VAR Names : pName;
          VAR line4 : pPassword;
Begin
     assign  (t,'areas.bbs');
     rewrite (t);

     { Okay, FIRST get the start address of the areas linked list }
     Line:=StartAreas;
     repeat
           s:=Line^.Conf;          { now get group and conference number }
           s:=s+#9+Line^.Group;
           Write (T,s);

           { Now write out NODES in areas list }
           Line2:=Line^.Node;
           while (Line2<>NIL) do
           Begin
                s:=#9+Line2^.Node;
                Line2:=Line2^.Next;
                Write (t,s);
           End;
           Line:=Line^.Next;
           Writeln (t);
     until (Line=NIL);
     Close (T);


     assign (t,'wcTOSS.dat');
     rewrite (t);

     writeln (t,Netmail);
     writeln (t,Badmail);
     writeln (t,InPath);
     writeln (t,Dest);
     writeln (t,Name);
     writeln (t,packer);
     writeln (t,packerO);
     writeln (t,unpacker);
     writeln (t,unpackerO);

     { Write out AKAs }
     Writeln (t,'-AKAS-');
     Aka:=AkaStart;
     while (Aka<>NIL) do
     Begin
          s:=Aka^.add;
          Writeln (t,s);
          Aka:=Aka^.Next;
     End;

     { Write out Names }
     Writeln (t,'-NAMES-');
     Names:=NameStart;
     while (Names<>NIL) do
     Begin
          s:=Names^.Name;
          Writeln (t,s);
          Names:=Names^.Next;
     End;

     { Write out TagLines }
     Writeln (t,'-TAGS-');
     Tag:=TagStart;
     while (Tag<>NIL) do
     Begin
          s:=Tag^.Tag;
          Writeln (t,s);
          Tag:=Tag^.Next;
     End;

     { Write out Conferences }
     Writeln (t,'-CONFS-');
     Conf:=ConfStart;
     while (Conf<>NIL) do
     Begin
          s:=Rstr(Conf^.Conf);
          Writeln (t,s);
          s:=Rstr(Conf^.Tag);
          Writeln (t,s);
          s:=Rstr(Conf^.Add);
          Writeln (t,s);
          Conf:=Conf^.Next;
     End;

	{ End List }
     Writeln (t,'-END-');
     close (t);

End;

(***************************************************************************)
(*
(*	Select Packer
(*
(***************************************************************************)
Function EnterOption (c,b : word;  S,def : string) : string;
	    VAR w1 : word;

Begin
	w1:=PrintOption (c,b,5,S);
     Def:=ReadInText (c,b,17,Def,60,80);
     CloseWindow (w1);
     EnterOption:=Def;
End;

(***************************************************************************)
(*
(*	Select Options
(*
(***************************************************************************)
Procedure SelectOption (Header:string; Data : pInput; Lines : integer);
	    VAR w1 : word;
         VAR xx,yy,i: integer;
         VAR len: integer;
         VAR def : string;
         VAR index : integer;
Begin
     yy:=(25-Lines-2) div 2;
     len:=(Data^[1].Start-1)+Data^[1].Len+2;
     xx:=(80-len) div 2;

	w1:=OpenWindow(xx,yy,len,Lines+2, 10,1);
     tc:=15;
     MyWriteln(-1,yy-1,Header);
     for i:=1 to Lines do
     Begin
         MyWrite(xx+1,yy+i,Data^[i].txt);
	    s:=Inputs[i];
         s:=copy(s,1,Data^[i].len);
         MyWriteln(xx+Data^[i].Start,yy+i,s);
     End;


     index:=1;
     repeat
           Inputs[index]:=InputText (Inputs[index],xx+Data^[index].Start,yy+index,Data^[index].len,Data^[index].max);
           if UpDir then if index>1 then dec (index);
           if DownDir then if index<Lines then inc (index);
     until (QuitInput);
     CloseWindow (w1);
End;

(***************************************************************************)
(*
(*	Set Address
(*
(***************************************************************************)
Procedure SelectAddress;
		VAR w1,w2 : word;

Begin
	w1:=PrintOption (15,3,5,'Enter YOUR internet address');
	address:=ReadInText (15,3,17,address,40,80);
     CloseWindow (w1);
End;

(***************************************************************************)
(*
(*	Set news destination address
(*
(***************************************************************************)
Procedure SelectDest;
		VAR w1,w2 : word;

Begin
	w1:=PrintOption (15,5,5,'Enter Dest address for news');
	dest:=ReadInText (15,5,17,dest,40,80);
     CloseWindow (w1);
End;


(***************************************************************************)
(*
(*   INSERT a new group
(*
(***************************************************************************)
Procedure InsertGroup(s,s2 : string; VAR Start : pLine; VAR cur,Max : longint;where : boolean);
          VAR here : pLine;
          VAR conf,group : string;
          VAR len : integer;
          VAR w1 : integer;
Begin
     here:=NIL;
     if Start<>NIL then    { delete a GROUP }
	  Begin
          Len:=0;
		Line:=Start;
          Last:=NIL;
		while (len<>Cur) do
          Begin
               inc (len);
               if (len=cur) Then
			Begin
                    if where=Before then here:=Last else here:=Line;

               End;
               Last:=Line;
               Line:=Line^.Next;
          End;
       End;

     Group:='';
     Conf:='';
	w1:=PrintOption (15,5,5,s);
	Group:=ReadInText (15,5,17,group,40,80);
     CloseWindow (w1);

     if s2<>'' then
     Begin
	     w1:=PrintOption (15,5,5,s2);
	     Conf:=ReadInText (15,5,17,Conf,40,5);
          CloseWindow (w1);
     End;

     if (Conf='') and (group='') then exit;

     new (Line);
     if here=NIL then
      Begin
          here:=Start;
          Start:=Line;
      	cur:=1;
      End
     else
      Begin
          Last:=here;
          here:=here^.Next;
          Last^.next:=Line;
      End;

     Line^.Next:=here;
     Line^.Group:=Group;
     Line^.Conf:=Conf;
     Line^.Node:=NIL;
     inc (Max);
End;


(***************************************************************************)
(*
(*   Edit a new group (Cur
(*
(***************************************************************************)
Procedure EditGroup(s,s2 : string; VAR start : pLine; VAR cur,Max : longint);
          VAR here : pLine;
          VAR conf,group : string;
          VAR len : integer;
          VAR w1 : integer;
Begin
     if Start=NIL then exit;
     if Start<>NIL then    { delete a GROUP }
	  Begin
          Len:=0;
		Line:=Start;
          Last:=NIL;
		while (len<>Cur) do
          Begin
               inc (len);
               if (len=cur) Then
			Begin
                    here:=Line;
               End;
               Last:=Line;
               Line:=Line^.Next;
          End;
       End;

     Group:=here^.group;
     Conf:=here^.Conf;
	w1:=PrintOption (15,5,5,s);
	Group:=ReadInText (15,5,17,group,40,80);
     CloseWindow (w1);

     if s2<>'' then
     Begin
	   w1:=PrintOption (15,5,5,s2);
	   Conf:=ReadInText (15,5,17,Conf,40,5);
        CloseWindow (w1);
     End;

     here^.Group:=Group;
     here^.Conf:=Conf;
End;




(***************************************************************************)
(*
(* Print Help for Group editing
(*
(***************************************************************************)
Procedure DoHelpGroups;
          VAR w2,w1 : word;
Begin
     w2:=Cwind;

	W1:=OpenWindow(15,5,50,15, 15,3);
     MyWriteln (15,5,'#cF#b3Group Editing');
     MyWriteln (none,none,'#cF#b3-------------');

     MyWriteln (none,none,'#cF#b3Key          #cEDescription');
     MyWriteln (none,none,'#cF#b3---          #cE-----------');
     MyWriteln (none,none,'#cF#b3<Insert>     #cEinsert a NEW group into list');
     MyWriteln (none,none,'#cF#b3             #cEAT the current group.       ');
     MyWriteln (none,none,'#cF#b3"a"          #cEinsert a NEW group into list');
     MyWriteln (none,none,'#cF#b3             #cEAFTER current group.        ');
     MyWriteln (none,none,'#cF#b3<Delete>     #cEDelete Current Group.');
     MyWriteln (none,none,'#cF#b3<Enter>      #cEEdit The Current Group');

     MyWriteln (none,none,'#cF#b3<UpArrow>    #cEMove Selection Bar UP one');
     MyWriteln (none,none,'#cF#b3<DownArrow>  #cEMove Selection Bar DOWN one');
     MyWriteln (none,none,'#cF#b3<PageUp>     #cEMove Selection Bar UP one page');
     MyWriteln (none,none,'#cF#b3<PageDOWN>   #cEMove Selection Bar DOWN one page');
     MyWriteln (none,none,'#cF#b3<Escape>     #cEQuits Current selection');

     repeat until (keypressed);
     Key:=GetKey;
     Key:=#0;
     CloseWindow(W1);
     SetWindow(W2);

End;

(***************************************************************************)
(*
(* Edit NODES (hanging off areas);
(*
(***************************************************************************)
Function EditNodes (VAR p: pointer; call : boolean): boolean;
Begin
     if (Call=true) then
     Begin
          EditList('Enter FIDO address','',20,p,False,15,2,$0E);
     End;
End;

(***************************************************************************)
(*
(*	Select an option
(*
(***************************************************************************)
Function SelectOne (s1 : string; Xsize,baseV : word; base : pointer) : word;
		VAR w1,w2 : word;
          VAR y,l2,len,x : integer;
		VAR i,xx,yy : integer;
          VAR pp : integer;
          VAR ch : char;
          VAR cur,Max,ll : longint;
          VAR Ypos : longint;
          VAR cc : pLine;
          VAR Start : pLine;
          VAR xs,xs2 : integer;
          VAR s : string;

Begin
     xs2:=Xsize;
     xs:=(80-Xsize+2) div 2;
     Start:=base;
	W1:=OpenWindow(xs,2,xs2,21, 15,2);
     Line:=Start;
     Max:=0;
     while (Line<>NIL) do
     Begin
		inc (Max);
		Line:=Line^.Next;
     End;


     Cur:=baseV;
     key:=#0;
     Ypos:=1;
	repeat
          case key of
            #13 : Begin
					CloseWindow(w1);
		  			SelectOne:=Cur;
					Exit;
            	   End;
            'P' : begin
            			inc (Cur);
                    	if Cur>Max then Cur:=Max;
                         if Cur>Ypos+18 then inc (Ypos);
                  End;
            'H' : Begin
            		dec (Cur);
                    if Cur=0 then Cur:=1;
                    if Cur<Ypos then Ypos:=Cur;
                  End;
            'Q' : begin
            	   		inc (Cur,18);
                    	if Cur>Max then Cur:=Max;
                         Ypos:=Cur;
                  End;
            'I' : begin
            			dec (Cur,18);
                    	if Cur<=0 then Cur:=1;
                         Ypos:=Cur;
                  End;
          end;
          xx:=2; yy:=2;
     	Line:=Start; len:=0; pp:=0;
          SetWindow(W1);
		MyWriteln(xs,2,'#cA#b1');
          tc:=$0E;
     	while (Line<>NIL) do
          Begin
          	inc (len);
               if (len>=Ypos) and (PP<19) Then
			Begin
                 if Cur=Len then
                  Begin
                      Tb:=0;
                      cc:=Line;
                  End
                 else
                   Tb:=2;
                 s:=Line^.Group;
                 s:=s+spc(61-Length(s));
                 s:=s+Line^.Conf;
                 s:=s+spc(7-Length(Line^.conf));
                 s:=copy(s,1,xsize-1);
			  MyWriteln   (xs,none,s);
                 inc (PP);
			End;
               Line:=Line^.Next;
          End;

          tb:=2;
		if PP<19 then
          repeat
          	MyWriteln (none,none,spc(Xsize-1));
               inc (PP);
          until (PP=19);


          key:=#0;
          repeat until (keypressed);
     	key:=getkey;
     until (key=#27);
	CloseWindow(w1);
End;

(***************************************************************************)
(*
(*	Set news destination address (base off linked list,Can I call a LINK?)
(*
(***************************************************************************)
Procedure delete_akatag(confer : word);
		VAR Lconf,Conf : pConf;
		VAR Tag,Aka : integer;
Begin
	Conf:=ConfStart;
     LConf:=NIL;
     while (Conf<>NIL) and (Conf^.conf<>Confer) do
     Begin
          LConf:=Conf;
		Conf:=Conf^.next;
	End;
     if Conf=NIL then exit;

     if conf=ConfStart then ConfStart:=Conf^.next;
     if Lconf<>NIL then Lconf^.next:=Conf^.next;
     dispose (conf);

End;
(***************************************************************************)
(*
(*	Set news destination address (base off linked list,Can I call a LINK?)
(*
(***************************************************************************)
Procedure SelectAKA (Group : pLine);
		VAR Lconf,Conf : pConf;
		VAR Tag,Aka : integer;
begin
	Conf:=ConfStart;
     LConf:=NIL;
     while (Conf<>NIL) and (Conf^.conf<>rval(Group^.Conf)) do
     Begin
          LConf:=Conf;
		Conf:=Conf^.next;
	End;

     Aka:=1;
     Tag:=1;
     if Conf<>NIL then
     Begin
		Tag:=Conf^.Tag;
		Aka:=Conf^.add;
     End;


     Aka:=SelectOne ('Select address for conference',25,aka,AKASTart);
     Tag:=SelectOne ('Select an Origin line for conference',62,tag,TagSTart);


	if Conf=Nil then
     Begin
     	new (Conf);
          Conf^.Next:=Nil;
          Conf^.Conf:=rval(Group^.conf);
          if Lconf=NIL then
          	ConfStart:=Conf
          else
             Lconf^.Next:=Conf;
	End;

     Conf^.Add:=aka;
     Conf^.Tag:=tag;
End;


(***************************************************************************)
(*
(*	Set news destination address (base off linked list,Can I call a LINK?)
(*
(***************************************************************************)
Function EditList (s1,s2 : string; Xsize : word; VAR base : pointer;Call : boolean; c,b,tcol :word) : boolean;
		VAR w1,w2 : word;
          VAR y,l2,len,x : integer;
		VAR i,xx,yy : integer;
          VAR pp : integer;
          VAR ch : char;
          VAR cur,Max,ll : longint;
          VAR Ypos : longint;
          VAR cc : pLine;
          VAR Start : pLine;
          VAR xs,xs2 : integer;
          VAR s : string;
          VAR confer : word;

Begin
     xs2:=Xsize;
     xs:=(80-Xsize+2) div 2;
     Start:=base;
	W1:=OpenWindow(xs,2,xs2,21, c,b);
     Line:=Start;
     Max:=0;
     while (Line<>NIL) do
     Begin
		inc (Max);
		Line:=Line^.Next;
     End;


     Cur:=1;
     key:=#0;
     Ypos:=1;
	repeat
          case key of
            ';' : DoHelpGroups;
            'R' : InsertGroup (s1,s2,Start,Cur,Max,before);
        'a','A' : InsertGroup (s1,s2,Start,Cur,Max,after);
            #13 : EditGroup (s1,s2,Start,Cur,Max);
            'S' : if Start<>NIL then    { delete a GROUP }
		        Begin
                   Len:=0;
		  	    Line:=Start;
                   Last:=NIL;
		  	    while (len<>Cur) do
          		Begin
          			inc (len);
               		if (len=cur) Then
					Begin
                              Confer:=rval(Line^.conf);
                 			if Cur=Len then Tb:=0 else Tb:=1;
                              if Last<>NIL then
							Last^.Next:=Line^.Next
                              else
                              	Start:=Line^.Next;
                          	dispose (Line); { free memory }
                              dec (Max);
                              if Cur>Max then Begin Cur:=Max; Len:=Cur; End;
                              if Cur<Ypos then Ypos:=Cur;
                         End;
                         Last:=Line;
               		Line:=Line^.Next;
                    End;
            	     if (call=true) then delete_akatag(confer);
                  End;


            'P' : begin
            			inc (Cur);
                    	if Cur>Max then Cur:=Max;
                         if Cur>Ypos+18 then inc (Ypos);
                  End;
            'H' : Begin
            		dec (Cur);
                    if Cur=0 then Cur:=1;
                    if Cur<Ypos then Ypos:=Cur;
                  End;
            'Q' : begin
            	   		inc (Cur,18);
                    	if Cur>Max then Cur:=Max;
                         Ypos:=Cur;
                  End;
            'I' : begin
            			dec (Cur,18);
                    	if Cur<=0 then Cur:=1;
                         Ypos:=Cur;
                  End;
            'n','N' : EditNodes(cc^.Node,call);
            't','T' : if (call=true) then
            			SelectAKA (cc);
          end;
          xx:=2; yy:=2;
     	Line:=Start; len:=0; pp:=0;
          SetWindow(W1);
		MyWriteln(xs,2,'#cA#b1');
          tc:=tcol;
     	while (Line<>NIL) do
          Begin
          	inc (len);
               if (len>=Ypos) and (PP<19) Then
			Begin
                 if Cur=Len then
                  Begin
                      Tb:=0;
                      cc:=Line;
                  End
                 else
                   Tb:=b;
                 s:=Line^.Group;
                 s:=s+spc(61-Length(s));
                 s:=s+Line^.Conf;
                 s:=s+spc(7-Length(Line^.conf));
                 s:=copy(s,1,xsize-1);
			  MyWriteln   (xs,none,s);
                 inc (PP);
			End;
               Line:=Line^.Next;
          End;

          tb:=b;
		if PP<19 then
          repeat
          	MyWriteln (none,none,spc(Xsize-1));
               inc (PP);
          until (PP=19);


          key:=#0;
          repeat until (keypressed);
     	key:=getkey;
     until (key=#27);
	CloseWindow(w1);
     base:=Start;
End;

(***************************************************************************)
(*
(*	Main setup
(*
(***************************************************************************)
Begin
     HelpData:=@HelpFile;
	PrintScreen;
     Packer:='c:\packers\pkzip.exe';
     PackerO:='';
     UNPacker:='c:\packers\pkunzip.exe';
     UNPackerO:='';
     Address:='2:259/71';
	Dest:='c:\fd\outfiles';
	InPath:='c:\fd\files';
	NetMail:='c:\fd\netmail';
	BadMail:='c:\fd\badmail';
     Orig:='Scotch Mist BBS! +44 1382 644 820 (2:259/71)';
     Name:='Joe Bloggs';
	readAreas;  { read in areas.bbs  }
     readcfg;    { read in wcTOSS.dat }

     w1:=-1;
     Option:=1;
     repeat
          if W1<>-1 then SetWindow (W1);
		Menus[1]:='#cF#b1Set Your Name             ';
		Menus[2]:='#cF#b1Set Netmail Path          ';
		Menus[3]:='#cF#b1Set Badmail Path          ';
		Menus[4]:='#cF#b1Set incoming Mail Path    ';
		Menus[5]:='#cF#b1Set Outgoing Mail Path    ';
		Menus[6]:='#cF#b1Set Packer Name and Path  ';
		Menus[7]:='#c7#b1 ';
		Menus[8]:='#cE#b1Edit Address And AKA''s    ';
		Menus[9]:='#cE#b1Edit Origin lines         ';
		Menus[10]:='#cE#b1Edit CrashMail access     ';
		Menus[11]:='#cE#b1Edit groups               ';
		Menus[12]:='#c7#b1 ';
		Menus[13]:='#cA#b1Save and Quit            ';
		Menus[14]:='#cA#b1Quit                     ';
     	Option:=Menu(15,1,Option,14,HelpData,w1);

          case Option of
            1	:  Begin
                       Inputs[1]:=Name;
                       SelectOption(' Enter SYSOP Name ',@P_Name,1);
                       Name:=Inputs[1];
                  End;
            2	:  Begin
                       Inputs[1]:=NetMail;
                       SelectOption(' Enter Netmail Path ',@P_Path,1);
                       NetMail:=Inputs[1];
                  End;
            3	:  Begin
                       Inputs[1]:=BadMail;
                       SelectOption(' Enter Badmail Path ',@P_Path,1);
                       BadMail:=Inputs[1];
                  End;
            4	:  Begin
                       Inputs[1]:=InPath;
                       SelectOption(' Enter Incoming Mail Path ',@P_Path,1);
                       InPath:=Inputs[1];
                  End;
            5	:  Begin
                       Inputs[1]:=Dest;
                       SelectOption(' Enter Outgoing Mail Path ',@P_Path,1);
                       Dest:=Inputs[1];
                  End;
            6	: Begin
		  		Inputs[1]:=packer;
		  		Inputs[2]:=packerO;
		  		Inputs[3]:=unpacker;
		  		Inputs[4]:=unpackerO;

                    SelectOption(' Enter Packer Details ',@P_Packer,4);

		  		packer:=Inputs[1];
		  		packerO:=Inputs[2];
		  		unpacker:=Inputs[3];
		  		unpackerO:=Inputs[4];

			   End;
            8  :  Begin
                       p:=AKASTart;
                       EditList('Enter Your list of addresses (ie 2:259/71, 25:1500/0)','',25,p,false,15,1,$a);
                       AKASTart:=p;
                  End;
            9  :  Begin
                       p:=TagSTart;
                       EditList('Enter new Origin line into list','',62,p,false,15,1,$a);
                       TagStart:=p;
                  End;
            10 :  Begin
                       p:=NameStart;
                       EditList('Enter USER to give CRASH mail access to','',50,p,false,15,1,$a);
				   NameStart:=p;
                  End;
            11  : Begin
                       p:=StartAreas;
                       EditList('Enter newsgroup','Enter Conference number',67,p,True,15,1,$a);
                       StartAreas:=p;
                  End;
            13	:  Begin SaveGroups; Option:=14; End;
          End;


	until (Option=14);
	CloseWindow (W1);
     TextColor (7);
     TextBackground (0);
     window(1,1,80,25);
	ClrScr;
     Writeln ('Finished.');
     Writeln;
End.

